From 59b7c12ffc75c45f16009da2ae1119a66f1ec910 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 10 2020 19:04:08 +0000
Subject: [PATCH 245/2232] Merge pull request #97 from dtolnay/isize


Define rust::isize with Windows support
---

diff --git a/gen/include.rs b/gen/include.rs
index e3a9dd7..8f38fe3 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -38,6 +38,7 @@ pub struct Includes {
     pub string: bool,
     pub type_traits: bool,
     pub utility: bool,
+    pub base_tsd: bool,
 }
 
 impl Includes {
@@ -88,6 +89,11 @@ impl Display for Includes {
         if self.utility {
             writeln!(f, "#include <utility>")?;
         }
+        if self.base_tsd {
+            writeln!(f, "#if defined(_WIN32)")?;
+            writeln!(f, "#include <BaseTsd.h>")?;
+            writeln!(f, "#endif")?;
+        }
         if *self != Self::default() {
             writeln!(f)?;
         }
diff --git a/gen/write.rs b/gen/write.rs
index 217a591..d80e957 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -110,6 +110,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     let mut needs_rust_str = false;
     let mut needs_rust_box = false;
     let mut needs_rust_fn = false;
+    let mut needs_rust_isize = false;
     for ty in types {
         match ty {
             Type::RustBox(_) => {
@@ -124,6 +125,10 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
             Type::Fn(_) => {
                 needs_rust_fn = true;
             }
+            ty if ty == Isize => {
+                out.include.base_tsd = true;
+                needs_rust_isize = true;
+            }
             ty if ty == RustString => {
                 out.include.array = true;
                 out.include.cstdint = true;
@@ -181,6 +186,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
         || needs_rust_box
         || needs_rust_fn
         || needs_rust_error
+        || needs_rust_isize
         || needs_unsafe_bitcopy
         || needs_manually_drop
         || needs_maybe_uninit
@@ -199,6 +205,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     write_header_section(out, needs_rust_box, "CXXBRIDGE02_RUST_BOX");
     write_header_section(out, needs_rust_fn, "CXXBRIDGE02_RUST_FN");
     write_header_section(out, needs_rust_error, "CXXBRIDGE02_RUST_ERROR");
+    write_header_section(out, needs_rust_isize, "CXXBRIDGE02_RUST_ISIZE");
     write_header_section(out, needs_unsafe_bitcopy, "CXXBRIDGE02_RUST_BITCOPY");
 
     if needs_manually_drop {
@@ -689,7 +696,7 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             Some(I16) => write!(out, "int16_t"),
             Some(I32) => write!(out, "int32_t"),
             Some(I64) => write!(out, "int64_t"),
-            Some(Isize) => write!(out, "ssize_t"),
+            Some(Isize) => write!(out, "::rust::isize"),
             Some(F32) => write!(out, "float"),
             Some(F64) => write!(out, "double"),
             Some(CxxString) => write!(out, "::std::string"),
diff --git a/include/cxx.h b/include/cxx.h
index 5de479c..27034f0 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -7,6 +7,9 @@
 #include <string>
 #include <type_traits>
 #include <utility>
+#if defined(_WIN32)
+#include <BaseTsd.h>
+#endif
 
 namespace rust {
 inline namespace cxxbridge02 {
@@ -180,6 +183,15 @@ private:
 };
 #endif // CXXBRIDGE02_RUST_ERROR
 
+#ifndef CXXBRIDGE02_RUST_ISIZE
+#define CXXBRIDGE02_RUST_ISIZE
+#if defined(_WIN32)
+using isize = SSIZE_T;
+#else
+using isize = ssize_t;
+#endif
+#endif // CXXBRIDGE02_RUST_ISIZE
+
 std::ostream &operator<<(std::ostream &, const String &);
 std::ostream &operator<<(std::ostream &, const Str &);
 

